/******************************************************************************
 * JBoss, a division of Red Hat                                               *
 * Copyright 2006, Red Hat Middleware, LLC, and individual                    *
 * contributors as indicated by the @authors tag. See the                     *
 * copyright.txt in the distribution for a full listing of                    *
 * individual contributors.                                                   *
 *                                                                            *
 * This is free software; you can redistribute it and/or modify it            *
 * under the terms of the GNU Lesser General Public License as                *
 * published by the Free Software Foundation; either version 2.1 of           *
 * the License, or (at your option) any later version.                        *
 *                                                                            *
 * This software is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU           *
 * Lesser General Public License for more details.                            *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public           *
 * License along with this software; if not, write to the Free                *
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA         *
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.                   *
 ******************************************************************************/
package org.example.project;

import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.portlet.StateAwareResponse;

import org.jboss.portletbridge.seam.PortalIdentity;
import org.jboss.portletbridge.seam.PortletScope;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

@Name("portletA")
@Scope(ScopeType.SESSION)
@PortletScope(PortletScope.ScopeType.APPLICATION_SCOPE)
public class portletA {

    private String user;
    private Object response;

    public void sendEvent(ActionEvent ae) {
        if (response instanceof StateAwareResponse) {
            StateAwareResponse stateResponse = (StateAwareResponse) response;
            stateResponse.setEvent(MyEvent.QNAME, new MyEvent("myCoolId"));
        }
    }

    public void publishParameter(ActionEvent ae) {
        if (response instanceof StateAwareResponse) {
            StateAwareResponse stateResponse = (StateAwareResponse) response;
            stateResponse.setRenderParameter("prpExample", "MyParamValue");
        }
    }

    public String getUser() {
        if (PortalIdentity.instance().isLoggedIn()) {
            user = PortalIdentity.instance().getPrincipal().getName();
        }
        return user;
    }

    public void setUser(String user) {
        this.user = user;
    }

    public Object getResponse() {
        response = FacesContext.getCurrentInstance().getExternalContext().getResponse();
        return response;
    }

    public void setResponse(Object response) {
        this.response = response;
    }
}
