/******************************************************************************
 * JBoss, a division of Red Hat                                               *
 * Copyright 2006, Red Hat Middleware, LLC, and individual                    *
 * contributors as indicated by the @authors tag. See the                     *
 * copyright.txt in the distribution for a full listing of                    *
 * individual contributors.                                                   *
 *                                                                            *
 * This is free software; you can redistribute it and/or modify it            *
 * under the terms of the GNU Lesser General Public License as                *
 * published by the Free Software Foundation; either version 2.1 of           *
 * the License, or (at your option) any later version.                        *
 *                                                                            *
 * This software is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU           *
 * Lesser General Public License for more details.                            *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public           *
 * License along with this software; if not, write to the Free                *
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA         *
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.                   *
 ******************************************************************************/
package org.example.project;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.EventListener;
import java.util.EventObject;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.jboss.seam.annotations.datamodel.DataModel;


import org.ajax4jsf.event.PushEventListener;
import org.jboss.portletbridge.seam.PortletScope;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.Synchronized;
import org.jboss.seam.annotations.datamodel.DataModelSelection;
import org.richfaces.component.html.HtmlExtendedDataTable;
import org.richfaces.model.selection.SimpleSelection;

@Name("portletCBean")
@Scope(ScopeType.SESSION)
@PortletScope(PortletScope.ScopeType.APPLICATION_SCOPE)
@Synchronized(timeout=10000)
public class portletC implements Runnable {

	protected String uuid = "";
	
	protected String text;
	
	protected boolean enabled = false;
	
	protected Date startDate;
	
	protected PushEventListener listener;

	protected Thread thread;

	// private int eventsFired counter;

	public void addListener(EventListener listener) {
		synchronized (listener) {
			if (this.listener != listener) {
				this.listener = (PushEventListener) listener;
			}
		}
	}

	public void run() {
            if (startDate == null)
                startDate = new Date();
            
		while (thread != null) {
			try {
				if (((new Date()).getTime()-startDate.getTime())>=60000) {
					stop();
				}
				//uuid = UUID.randomUUID().toString();
				listener.onEvent(new EventObject(this));
				thread.sleep(10);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				// e.printStackTrace();
			}
		}
	}

	public String getUuid() {
		return uuid;
	}

	public void start() {
		if (thread == null) {
			thread = new Thread(this);
			thread.setDaemon(true);
			thread.start();
			setStartDate(new Date());
			setEnabled(true);
		}
	}

	public void stop() {
		if (thread != null) {
			//thread.stop();
			setStartDate(null);
			setEnabled(false);
			thread = null;
		}
	}

	public Thread getThread() {
		return thread;
	}

	public boolean isEnabled() {
		return enabled;
	}

	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}

	public Date getStartDate() {
		return startDate;
	}

	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}

	public String getText() {
		return text;
	}

	public void setText(String text) {
        try {
            thread.sleep(10000);
        } catch (InterruptedException ex) {
            Logger.getLogger(portletC.class.getName()).log(Level.SEVERE, null, ex);
        }
        Opportunity opp = new Opportunity();
        opp.setDescription("sss");
        opp.setCifId("1");
        if (opportunities == null)
            opportunities = new ArrayList<Opportunity>();
        opportunities.add(opp);
        this.text = text;
	}

        //Table
    @DataModel("opportunities")
    private List<Opportunity> opportunities;
    @DataModelSelection
    private Opportunity selectedRow;

    @In(required = false)
    @Out(required = false)
    private HtmlExtendedDataTable table;

    public SimpleSelection selection;

    public HtmlExtendedDataTable getTable() {
        return table;
    }

    public void setTable(HtmlExtendedDataTable table) {
        this.table = table;
    }

    public SimpleSelection getSelection() {
        return selection;
    }

    public void setSelection(SimpleSelection selection) {
        this.selection = selection;
    }
    
    public void rowSelected() {


    }


    public List<Opportunity> getOpportunities() {
        return opportunities;
    }

    public void setOpportunities(List<Opportunity> opportunities) {
        this.opportunities = opportunities;
    }

    public Opportunity getSelectedRow() {
        return selectedRow;
    }

    public void setSelectedRow(Opportunity selectedRow) {
        this.selectedRow = selectedRow;
    }
}
